By using the APIENGINE.IO web site ("Service"), or any services of Fourtribe (trading as APIENGINE.IO), you are agreeing to be bound by the following terms and conditions ("Terms of Service"). IF YOU ARE ENTERING INTO THIS AGREEMENT ON BEHALF OF A COMPANY OR OTHER LEGAL ENTITY, YOU REPRESENT THAT YOU HAVE THE AUTHORITY TO BIND SUCH ENTITY, ITS AFFILIATES AND ALL USERS WHO ACCESS OUR SERVICES THROUGH YOUR ACCOUNT TO THESE TERMS AND CONDITIONS, IN WHICH CASE THE TERMS "YOU" OR "YOUR" SHALL REFER TO SUCH ENTITY, ITS AFFILIATES AND USERS ASSOCIATED WITH IT. IF YOU DO NOT HAVE SUCH AUTHORITY, OR IF YOU DO NOT AGREE WITH THESE TERMS AND CONDITIONS, YOU MUST NOT ACCEPT THIS AGREEMENT AND MAY NOT USE THE SERVICES.

APIENGINE.IO reserves the right to update and change the Terms of Service from time to time without notice. Any new features that augment or enhance the current Service, including the release of new tools and resources, shall be subject to the Terms of Service. Continued use of the Service after any such changes shall constitute your consent to such changes.

Violation of any of the terms below will result in the termination of your Account. While APIENGINE.IO prohibits such conduct and Content on the Service, you understand and agree that APIENGINE.IO cannot be responsible for the Content posted on the Service and you nonetheless may be exposed to such materials. You agree to use the Service at your own risk.

A. Account Terms
----------------
1.  You must be 13 years or older to use this Service.
2.  You must be a human. Accounts registered by "bots" or other automated methods are not permitted.
3.  You must provide your legal full name, a valid email address, and any other information requested in order to complete the signup process.
4.  Your login may only be used by one person - a single login shared by multiple people is not permitted. You may create separate logins for as many people as your plan allows.
5.  You are responsible for maintaining the security of your account and password. APIENGINE.IO cannot and will not be liable for any loss or damage from your failure to comply with this security obligation.
6.  You are responsible for all Content posted and activity that occurs under your account (even when Content is posted by others who have accounts under your account).
7.  You may not use the Service for any illegal or unauthorized purpose. You must not, in the use of the Service, violate any laws in your jurisdiction (including but not limited to copyright or trademark laws).

B. API Terms
------------
Customers may access their APIENGINE.IO account data via an API (Application Program Interface). Any use of the API, including use of the API through a third-party product that accesses APIENGINE.IO, is bound by these Terms of Service plus the following specific terms:

1.  You expressly understand and agree that APIENGINE.IO shall not be liable for any direct, indirect, incidental, special, consequential or exemplary damages, including but not limited to, damages for loss of profits, goodwill, use, data or other intangible losses (even if APIENGINE.IO has been advised of the possibility of such damages), resulting from your use of the API or third-party products that access data via the API.
2.  Abuse or excessively frequent requests to APIENGINE.IO via the API may result in the temporary or permanent suspension of your account's access to the API. APIENGINE.IO, in its sole discretion, will determine abuse or excessive usage of the API. APIENGINE.IO will make a reasonable attempt via email to warn the account owner prior to suspension.
3.  APIENGINE.IO reserves the right at any time to modify or discontinue, temporarily or permanently, your access to the API (or any part thereof) with or without notice.

C. Payment, Refunds, Upgrading and Downgrading Terms
----------------------------------------------------
1.  All paid plans must enter a valid credit card. Free accounts are not required to provide a credit card number.
2.  An upgrade from the free plan to any paying plan will immediately bill you.
3.  The Service is billed in advance on a monthly basis and is non-refundable. There will be no refunds or credits for partial months of service, upgrade/downgrade refunds, or refunds for months unused with an open account. In order to treat everyone equally, no exceptions will be made.
4.  All fees are exclusive of all taxes, levies, or duties imposed by taxing authorities, and you shall be responsible for payment of all such taxes, levies, or duties, excluding only United States (federal or state) taxes.
5.  For any upgrade or downgrade in plan level, your credit card that you provided will automatically be charged the new rate on your next billing cycle or immediately as per the current Pricing Plan.
6.  Downgrading your Service may cause the loss of Content, features, or capacity of your Account. APIENGINE.IO does not accept any liability for such loss.

D. Cancellation and Termination
-------------------------------
1.  You are solely responsible for properly canceling your account. An email or phone request to cancel your account is not considered cancellation. You can cancel your account at any time by navigating to Account settings. The Account settings screen provides a simple no questions asked cancellation link.
2.  All of your Content will be immediately deleted from the Service upon cancellation. This information can not be recovered once your account is cancelled.
3.  If you cancel the Service before the end of your current paid up month, your cancellation will take effect immediately and you will not be charged again.
4.  APIENGINE.IO, in its sole discretion, has the right to suspend or terminate your account and refuse any and all current or future use of the Service, or any other APIENGINE.IO service, for any reason at any time. Such termination of the Service will result in the deactivation or deletion of your Account or your access to your Account, and the forfeiture and relinquishment of all Content in your Account. APIENGINE.IO reserves the right to refuse service to anyone for any reason at any time.

E. Modifications to the Service and Prices
------------------------------------------
1.  APIENGINE.IO reserves the right at any time and from time to time to modify or discontinue, temporarily or permanently, the Service (or any part thereof) with or without notice.
2.  Prices of all Services, including but not limited to monthly subscription plan fees to the Service, are subject to change upon 30 days notice from us. Such notice may be provided at any time by posting the changes to the APIENGINE.IO Site (apiengine.io) or the Service itself.
3.  APIENGINE.IO shall not be liable to you or to any third party for any modification, price change, suspension or discontinuance of the Service.

F. Copyright and Content Ownership
----------------------------------
1.  APIENGINE.IO claims no intellectual property rights over the material you provide to the Service. Your profile and materials uploaded remain yours. However, by designating any of your APIs pages as public, you agree to allow others to view your Content.
2.  APIENGINE.IO does not pre-screen Content, but APIENGINE.IO and its designee have the right (but not the obligation) in their sole discretion to refuse or remove any Content that is available via the Service.
3.  You shall defend APIENGINE.IO against any claim, demand, suit or proceeding made or brought against APIENGINE.IO by a third party alleging that Your Content, or Your use of the Service in violation of this Agreement, infringes or misappropriates the intellectual property rights of a third party or violates applicable law, and shall indemnify APIENGINE.IO for any damages finally awarded against, and for reasonable attorney’s fees incurred by, APIENGINE.IO in connection with any such claim, demand, suit or proceeding; provided, that APIENGINE.IO (a) promptly gives You written notice of the claim, demand, suit or proceeding; (b) gives You sole control of the defense and settlement of the claim, demand, suit or proceeding (provided that You may not settle any claim, demand, suit or proceeding unless the settlement unconditionally releases APIENGINE.IO of all liability); and (c) provides to You all reasonable assistance, at Your expense.
4.  The look and feel of the Service is copyright ©2012 APIENGINE.IO All rights reserved. You may not duplicate, copy, or reuse any portion of the HTML/CSS, Javascript, or visual design elements or concepts without express written permission from APIENGINE.IO.

G. General Conditions
---------------------
1.  Your use of the Service is at your sole risk. The service is provided on an "as is" and "as available" basis.
2.  Technical support is only provided to paying account holders and is only available via email. Support is only available in English.
3.  You understand that APIENGINE.IO uses third party vendors and hosting partners to provide the necessary hardware, software, networking, storage, and related technology required to run the Service.
4.  You must not modify, adapt or hack the Service or modify another website so as to falsely imply that it is associated with the Service, APIENGINE.IO, or any other APIENGINE.IO service.
5.  You may use APIENGINE.IO subdomains (e.g., yourname.apiengine.io) solely as permitted and intended by the APIENGINE.IO Publish tool to host your company API information, or personal API information, and for no other purpose. You may not use APIENGINE.IO subdomains in violation of APIENGINE.IO's trademark or other rights or in violation of applicable law. APIENGINE.IO reserves the right at all times to reclaim any APIENGINE.IO subdomain without liability to you.
6.  You agree not to reproduce, duplicate, copy, sell, resell or exploit any portion of the Service, use of the Service, or access to the Service without the express written permission by APIENGINE.IO.
7.  We may, but have no obligation to, remove Content and Accounts containing Content that we determine in our sole discretion are unlawful, offensive, threatening, libelous, defamatory, pornographic, obscene or otherwise objectionable or violates any party's intellectual property or these Terms of Service.
8.  Verbal, physical, written or other abuse (including threats of abuse or retribution) of any APIENGINE.IO customer, employee, member, or officer will result in immediate account termination.
9.  You understand that the technical processing and transmission of the Service, including your Content, may be transfered unencrypted and involve (a) transmissions over various networks; and (b) changes to conform and adapt to technical requirements of connecting networks or devices.
10.  You must not upload, post, host, or transmit unsolicited email, SMSs, or "spam" messages.
11.  You must not transmit any worms or viruses or any code of a destructive nature.
12.  If your bandwidth usage significantly exceeds the average bandwidth usage (as determined solely by APIENGINE.IO) of other APIENGINE.IO customers, we reserve the right to immediately disable your account or throttle your file hosting until you can reduce your bandwidth consumption.
13.  APIENGINE.IO does not warrant that (i) the service will meet your specific requirements, (ii) the service will be uninterrupted, timely, secure, or error-free, (iii) the results that may be obtained from the use of the service will be accurate or reliable, (iv) the quality of any products, services, information, or other material purchased or obtained by you through the service will meet your expectations, and (v) any errors in the Service will be corrected.
14.  You expressly understand and agree that APIENGINE.IO shall not be liable for any direct, indirect, incidental, special, consequential or exemplary damages, including but not limited to, damages for loss of profits, goodwill, use, data or other intangible losses (even if APIENGINE.IO has been advised of the possibility of such damages), resulting from: (i) the use or the inability to use the service; (ii) the cost of procurement of substitute goods and services resulting from any goods, data, information or services purchased or obtained or messages received or transactions entered into through or from the service; (iii) unauthorized access to or alteration of your transmissions or data; (iv) statements or conduct of any third party on the service; (v) or any other matter relating to the service.
15.  The failure of APIENGINE.IO to exercise or enforce any right or provision of the Terms of Service shall not constitute a waiver of such right or provision. The Terms of Service constitutes the entire agreement between you and APIENGINE.IO and govern your use of the Service, superseding any prior agreements between you and APIENGINE.IO (including, but not limited to, any prior versions of the Terms of Service). You agree that these Terms of Service and Your use of the Service are governed under California law.
16.  Questions about the Terms of Service should be sent to support@apiengine.io.